LNDIR(1)

NAME
lndir - create a shadow directory of symbolic links to another directory tree

SYNOPSIS
lndir [-is] [-e exceptfile] fromdir [todir]

DESCRIPTION
The lndir program makes a shadow copy todir of a directory tree fromdir, except that the shadow is not populated with real files but instead with symbolic links pointing at the real files in the fromdir directory tree. This is usually useful for maintaining source code for different machine architectures. You create a shadow directory containing links to the real source, which you will have usually mounted from a remote machine. You can build in the shadow tree, and the object files will be in the shadow directory, while the source files in the shadow directory are just symlinks to the real files.

This scheme has the advantage that if you update the source, you need not propagate the change to the other architectures by hand, since all source in all shadow directories are symlinks to the real thing: just change working directory to the shadow directory and recompile away.

The todir argument is optional and defaults to the current directory. The fromdir argument may be relative (e.g. ../src) and is relative to todir (not the current directory).

If you add files, simply run lndir again. New files will be silently added. Old files will be checked that they have the correct link.

Deleting files is a more painful problem; the symlinks will just point into never never land.

The options are as follows:

-e exceptfile
    Add the specified file to the list of excluded files/directories. This is effective in all directories searched by lndir. This option may be specified as many times as needed.

    The following types of files are excluded by default:

    -   files whose names end in ‘~’
    -   files whose names start with ‘.#’
    -   RCS, SCCS, CVS, and CVS.adm directories

-i  If a file in fromdir is a symbolic link, lndir will make the same link in todir rather than making a link back to the (symbolic link) entry in fromdir. The -i flag changes that behavior, i.e. it causes the program to not treat symbolic links in fromdir specially. The link created in todir will point back to the corresponding (symbolic link) file in fromdir. If the link is to a directory, this is almost certainly the wrong thing.

    This option exists mostly to emulate the behavior the C version of lndir had in X11R6. Its use is not recommended.

-s  Suppresses status messages normally output as lndir descends into each subdirectory.

DIAGNOSTICS
The program displays the name of each subdirectory it enters, followed by a colon. The -s option suppresses these messages.

A warning message is displayed if the symbolic link cannot be created. The usual problem is that a regular file of the same name already exists.

If the link already exists but doesn't point to the correct file, the program prints the link name and the location where it does point.

SEE ALSO
find(1), ln(1), patch(1)

HISTORY
lndir was first distributed as part of X11.

This version first appeared in OpenBSD 1.2.

BUGS
The patch(1) program gets upset if it cannot change the files. You should never run patch(1) from a shadow directory anyway.

To clear out all files before you can relink (if fromdir moved, for instance):

    $ find todir -type l -print0 | xargs -0 -r rm

Find all files that are not directories:

    $ find . ! -type d -print0